<script setup>
const router = useRouter()

definePageMeta({
  middleware: ['auth', 'org']
})

const form = ref({
  id: '',
  organizationId: '',
  name: '',
  description: '',
  isActive: true,
  isDefault: false,
  countryId: '',
  processing: false,
  alert: {
    status: '',
    message: ''
  }
})

const back = () => {
  router.push('/admin/regions')
}

const save = async (record, id = '') => {
  const res = await $fetch('/api/admin/regions/store', {
    method: 'POST',
    headers: useRequestHeaders(['cookie']),
    body: {
      organizationId: record.organizationId,
      name: record.name,
      description: record.description,
      isActive: record.isActive,
      isDefault: record.isDefault,
      countryId: record.countryId,
    }
  })

  if(Number(res.status) === 200) {
    back()
  } else {
    form.value.alert.status = res.status
    form.value.alert.message = res.message
    form.value.processing = false
  }
}

const breadCrumb = computed(() => ([
  { link: '/admin', text: 'Admin'},
  { link: '/admin/regions', text: 'Regions'},
  { link: '#', text: 'Add Region', active: true}
]))
</script>

<template>
  <Head>
    <Title>Add Region</Title>
  </Head>

  <NuxtLayout name="admin">
    <div>
      <BreadCrumb :items="breadCrumb" class="mb-1.5rem" />

      <div class="card card-action mb-5">
        <div class="card-alert"></div>
        <div class="card-header">
          <h4 class="card-action-title">Add Region</h4>
          <div class="card-action-element">
            <button type="button" @click="back" class="btn btn-ms btn-secondary waves-effect waves-light">
              <span class="tf-icon ti ti-chevron-left ti-xs me-1"></span> Back
            </button>
          </div>
        </div>
        <div class="collapse show">
          <AdminRegionForm v-model="form" @save="save"/>
        </div>
      </div>

    </div>
  </NuxtLayout>
</template>